import * as React from 'react';
import {
  generateCompositeComponent,
  useComponentProps,
  reverseUseComponentProps
} from '@cloudbase/lowcode-render';
<%= componentImports %>;
<%= actionImports %>

export default React.forwardRef((props, ref) => {
  const { events, $node, className, style, emit,$widget,compositeParent,isInComposite,forIndexes, data } = reverseUseComponentProps(props);
  const [compositeComponent, setcompositeComponent] = React.useState(null);

  const item = <%= template %>;
  const componentsMap = {
    <% useComponents.forEach(compItem => {%>
    '<%= compItem.moduleName %>:<%= compItem.name %>': React.forwardRef((props,ref) => {
      const processedProps = useComponentProps(props, <%= compItem.isPlainProps? 1:0 %>);
      return <<%= upperFirst(compItem.var) %> {...processedProps} ref={ref}/>
    }),
    <% }) %>
  };
  const componentActionsMap = {
    <% useMaterialActions.forEach(action => {%>
      '<%= action.materialName %>:<%= action.name %>': <%= action.variableName %>,
    <% }) %>
  };

  const componentsInfoMap = <%= componentsInfo %>

  React.useEffect(() => {
    Promise.resolve(generateCompositeComponent({
        sourceKey: '',
        comp: item,
        module: '<%= materialName %>',
        componentsMap,
        componentActionsMap,
        componentsInfoMap,
        options: {
          enablePageRootId: false,
          lowcodeContext: {},
          looseError: true,
          processCssUnit: 'px',
          disablePageComponentInvoke: true,
        },
      }))
      .then((compositeComponent) => {
        setcompositeComponent(compositeComponent);
      });
  }, []);
  if (!compositeComponent) {
    return <></>;
  }
  const CompositeComponent = compositeComponent;

  return (
    <CompositeComponent
    events={events}
    $node={$node}
    $widget={$widget}
    compositeParent={compositeParent}
    isInComposite={isInComposite}
    forIndexes={forIndexes}
    className={className}
    style={style}
    data={data}
    ref={ref}
    emit={emit}
    ></CompositeComponent>
  );
});
